#pragma once

#define CINTERFACE

#include <ddraw.h>
#include <typeinfo>

template <typename Vtable>
struct DDrawVtableForEach;

template <typename Vtable, typename Visitor>
void forEach(Visitor& visitor)
{
	DDrawVtableForEach<Vtable>::forEach<Vtable>(visitor);
}

template <typename T>
std::string getTypeName()
{
	std::string typeName(typeid(T).name());
	if (0 == typeName.find("struct "))
	{
		typeName = typeName.substr(typeName.find(" ") + 1);
	}
	return typeName;
}

#define DD_VISIT(member) \
		visitor.visit<decltype(&Vtable::member), &Vtable::member>(getTypeName<Vtable>(), #member)

template <>
struct DDrawVtableForEach<IUnknownVtbl>
{
	template <typename Vtable, typename Visitor>
	static void forEach(Visitor& visitor)
	{
		DD_VISIT(QueryInterface);
		DD_VISIT(AddRef);
		DD_VISIT(Release);
	}
};
